<?php
/**
 * Core Design Favorite Pages module for Joomla! 2.5
 * @author		Daniel Rataj, <info@greatjoomla.com>
 * @package		Joomla 
 * @subpackage	Content
 * @category	Module
 * @version		2.5.x.2.0.3
 * @copyright	Copyright (C) 2007 - 2012 Great Joomla!, http://www.greatjoomla.com
 * @license		http://www.gnu.org/copyleft/gpl.html GNU/GPL 3
 * 
 * This file is part of Great Joomla! extension.   
 * This extension is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This extension is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */
 
// no direct access
defined( '_JEXEC' ) or die;

/**
* @package		Joomla
* @subpackage	Content
*/

class JTableCdFapa extends JTable
{
	/** @var int Primary key */
	public $id	= null;
	
	/** @var int */
	public $uid = null;
	
	/** @var string */
	public $title = '';
	
	/** @var string */
	public $link = '';
	
	/** @var string */
	public $note = '';
	
	/**
	 * A database connector object
	 * 
	 * @param database A database connector object
	 * @return void
	 */
	public function __construct( &$db )
	{
		parent::__construct( '#__cdfapa', 'id', $db );
		
		$user = JFactory::getUser();
		$this->set('uid', (int) $user->id);
		unset($user);
	}
	
	/**
	 * Create a database
	 * 
	 * @return boolean
	 */
	public function createDB()
	{
		$query = '
		  CREATE TABLE IF NOT EXISTS ' . $this->_tbl . ' (' .
		            '`id` INT(11) NOT NULL AUTO_INCREMENT,' .
		            '`uid` INT(11) DEFAULT NULL,' .
		            '`title` MEDIUMTEXT DEFAULT NULL,' .
		            '`link` MEDIUMTEXT DEFAULT NULL,' .
		            '`note` MEDIUMTEXT DEFAULT NULL,' .
		            ' PRIMARY KEY (`id`)' . ') ENGINE=MyISAM;';
	 
		$this->_db->setQuery($query);
		
		if (!$this->_db->query())
		{
			$this->setError($this->_db->stderr());
			return false;
		}
		return true;
	}
	
	/**
	 * Load DB data
	 * 
	 * @return mixed		array|boolean
	 */
	public function loadData($order_by = 'id', $order_dir = 'ASC')
	{
		$query = 'SELECT * FROM ' . $this->_tbl .
		' WHERE ' . $this->_db->nameQuote('uid') . ' = ' . $this->uid .
		' ORDER BY ' . $this->_db->nameQuote($order_by) . ' ' . $order_dir;
		$this->_db->setQuery($query);
		if (!$this->_db->query())
		{
			$this->setError($this->_db->stderr());
			return false;
		}
		return $this->_db->loadObjectList();
	}
	
	/**
	 * Check if the actual link already exists in DB table
	 * 
	 * @param $link
	 * @return integer
	 */
	public function getExistLink($link)
	{
        $query = 'SELECT `id` FROM ' . $this->_tbl .
        ' WHERE ' . $this->_db->nameQuote('uid') . ' = ' . $this->uid . ' AND '
        . $this->_db->nameQuote('link') . ' LIKE ' . $this->_db->Quote($link);
        $this->_db->setQuery($query);
		if (!$this->_db->query())
		{
			$this->setError($this->_db->stderr());
			return false;
		}
		$row = (int)$this->_db->loadResult();
        
        if ($row) return $row;
		return 0;
	}
	
	/**
	 * Get Last ID from DB
	 * 
	 * @return int
	 */
	public function getmyLastId()
	{
        $query = 'SELECT MAX(' . $this->_db->nameQuote('id') . ') FROM '
        . $this->_tbl . ' WHERE '
        . $this->_db->nameQuote('uid') . ' = ' . $this->uid;
        
        $this->_db->setQuery($query);
		if (!$this->_db->query())
		{
			$this->setError($this->_db->stderr());
			return false;
		}
        return (int) $this->_db->loadResult();
	}
}
?>